ir_node *new_rd_Div(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *mem, ir_node *left, ir_node *right, ir_mode * res_mode, op_pin_state state)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[3];
	in[0] = mem;
	in[1] = left;
	in[2] = right;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Div, mode_T, 3, in);
	res->attr.divmod.res_mode = res_mode;
	res->attr.divmod.exc.pin_state = state;
	res->attr.divmod.no_remainder = 0;
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Div(ir_graph *irg, ir_node *block, ir_node *mem, ir_node *left, ir_node *right, ir_mode * res_mode, op_pin_state state)
{
	return new_rd_Div(NULL, irg, block, mem, left, right, res_mode, state);
}

ir_node *new_d_Div(dbg_info *db, ir_node *mem, ir_node *left, ir_node *right, ir_mode * res_mode, op_pin_state state)
{
	ir_node *res;
	res = new_rd_Div(db, current_ir_graph, current_ir_graph->current_block, mem, left, right, res_mode, state);
	#if PRECISE_EXC_CONTEXT
	firm_alloc_frag_arr(res, op_Div, &res->attr.except.frag_arr);
	#endif
	return res;
}

ir_node *new_Div(ir_node *mem, ir_node *left, ir_node *right, ir_mode * res_mode, op_pin_state state)
{
	return new_d_Div(NULL, mem, left, right, res_mode, state);
}

ir_node *new_rd_Block(dbg_info *db, ir_graph *irg, int arity, ir_node **in)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, NULL, op_Block, mode_BB, arity, in);
	res->attr.block.irg = irg;
	res->attr.block.is_dead = 0;
	res->attr.block.is_mb_head = 1;
	res->attr.block.has_label = 0;
	res->attr.block.in_cg = NULL;
	res->attr.block.backedge = new_backedge_arr(irg->obst, arity);
	res->attr.block.cg_backedge = NULL;
	res->attr.block.extblk = NULL;
	res->attr.block.mb_depth = 0;
	res->attr.block.label = 0;
	/* macroblock header */
	res->in[0] = res;

	set_Block_matured(res, 1);
	set_Block_block_visited(res, 0);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Block(ir_graph *irg, int arity, ir_node **in)
{
	return new_rd_Block(NULL, irg, arity, in);
}

ir_node *new_d_Block(dbg_info *db, int arity, ir_node **in)
{
	ir_node *res;
	int i;
	int has_unknown = 0;
	res = new_rd_Block(db, current_ir_graph, arity, in);
	/* Create and initialize array for Phi-node construction. */
	if (get_irg_phase_state(current_ir_graph) == phase_building) {
		res->attr.block.graph_arr = NEW_ARR_D(ir_node *, current_ir_graph->obst,
		                                      current_ir_graph->n_loc);
		memset(res->attr.block.graph_arr, 0, sizeof(ir_node *) * current_ir_graph->n_loc);
	}

	for (i = arity-1; i >= 0; i--)
		if (is_Unknown(in[i])) {
		has_unknown = 1;
		break;
	}
	if (!has_unknown) res = optimize_node(res);
	current_ir_graph->current_block = res;
	IRN_VRFY_IRG(res, current_ir_graph);
	return res;
}

ir_node *new_Block(int arity, ir_node **in)
{
	return new_d_Block(NULL, arity, in);
}

ir_node *new_rd_Add(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *left, ir_node *right, ir_mode *mode)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[2];
	in[0] = left;
	in[1] = right;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Add, mode, 2, in);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Add(ir_graph *irg, ir_node *block, ir_node *left, ir_node *right, ir_mode *mode)
{
	return new_rd_Add(NULL, irg, block, left, right, mode);
}

ir_node *new_d_Add(dbg_info *db, ir_node *left, ir_node *right, ir_mode *mode)
{
	ir_node *res;
	res = new_rd_Add(db, current_ir_graph, current_ir_graph->current_block, left, right, mode);
	return res;
}

ir_node *new_Add(ir_node *left, ir_node *right, ir_mode *mode)
{
	return new_d_Add(NULL, left, right, mode);
}

ir_node *new_rd_Id(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *val, ir_mode *mode)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[1];
	in[0] = val;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Id, mode, 1, in);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Id(ir_graph *irg, ir_node *block, ir_node *val, ir_mode *mode)
{
	return new_rd_Id(NULL, irg, block, val, mode);
}

ir_node *new_d_Id(dbg_info *db, ir_node *val, ir_mode *mode)
{
	ir_node *res;
	res = new_rd_Id(db, current_ir_graph, current_ir_graph->current_block, val, mode);
	return res;
}

ir_node *new_Id(ir_node *val, ir_mode *mode)
{
	return new_d_Id(NULL, val, mode);
}

ir_node *new_rd_Const_type(dbg_info *db, ir_graph *irg, tarval * tv, ir_type * tp)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, get_irg_start_block(irg), op_Const, get_tarval_mode(tv), 0, NULL);
	res->attr.con.tv = tv;
set_Const_type(res, tp);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Const_type(ir_graph *irg, tarval * tv, ir_type * tp)
{
	return new_rd_Const_type(NULL, irg, tv, tp);
}

ir_node *new_d_Const_type(dbg_info *db, tarval * tv, ir_type * tp)
{
	ir_node *res;
	res = new_rd_Const_type(db, current_ir_graph, tv, tp);
	return res;
}

ir_node *new_Const_type(tarval * tv, ir_type * tp)
{
	return new_d_Const_type(NULL, tv, tp);
}

ir_node *new_rd_Start(dbg_info *db, ir_graph *irg, ir_node *block)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Start, mode_T, 0, NULL);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Start(ir_graph *irg, ir_node *block)
{
	return new_rd_Start(NULL, irg, block);
}

ir_node *new_d_Start(dbg_info *db)
{
	ir_node *res;
	res = new_rd_Start(db, current_ir_graph, current_ir_graph->current_block);
	return res;
}

ir_node *new_Start(void)
{
	return new_d_Start(NULL);
}

ir_node *new_rd_Tuple(dbg_info *db, ir_graph *irg, ir_node *block, int arity, ir_node **in)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Tuple, mode_T, arity, in);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Tuple(ir_graph *irg, ir_node *block, int arity, ir_node **in)
{
	return new_rd_Tuple(NULL, irg, block, arity, in);
}

ir_node *new_d_Tuple(dbg_info *db, int arity, ir_node **in)
{
	ir_node *res;
	res = new_rd_Tuple(db, current_ir_graph, current_ir_graph->current_block, arity, in);
	return res;
}

ir_node *new_Tuple(int arity, ir_node **in)
{
	return new_d_Tuple(NULL, arity, in);
}

ir_node *new_rd_End(dbg_info *db, ir_graph *irg, ir_node *block)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_End, mode_X, -1, NULL);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_End(ir_graph *irg, ir_node *block)
{
	return new_rd_End(NULL, irg, block);
}

ir_node *new_d_End(dbg_info *db)
{
	ir_node *res;
	res = new_rd_End(db, current_ir_graph, current_ir_graph->current_block);
	return res;
}

ir_node *new_End(void)
{
	return new_d_End(NULL);
}

ir_node *new_rd_Cmp(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *left, ir_node *right)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[2];
	in[0] = left;
	in[1] = right;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Cmp, mode_T, 2, in);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Cmp(ir_graph *irg, ir_node *block, ir_node *left, ir_node *right)
{
	return new_rd_Cmp(NULL, irg, block, left, right);
}

ir_node *new_d_Cmp(dbg_info *db, ir_node *left, ir_node *right)
{
	ir_node *res;
	res = new_rd_Cmp(db, current_ir_graph, current_ir_graph->current_block, left, right);
	return res;
}

ir_node *new_Cmp(ir_node *left, ir_node *right)
{
	return new_d_Cmp(NULL, left, right);
}

ir_node *new_rd_Cond(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *selector)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[1];
	in[0] = selector;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Cond, mode_T, 1, in);
	res->attr.cond.kind = dense;
	res->attr.cond.default_proj = 0;
	res->attr.cond.pred = COND_JMP_PRED_NONE;
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Cond(ir_graph *irg, ir_node *block, ir_node *selector)
{
	return new_rd_Cond(NULL, irg, block, selector);
}

ir_node *new_d_Cond(dbg_info *db, ir_node *selector)
{
	ir_node *res;
	res = new_rd_Cond(db, current_ir_graph, current_ir_graph->current_block, selector);
	return res;
}

ir_node *new_Cond(ir_node *selector)
{
	return new_d_Cond(NULL, selector);
}

ir_node *new_rd_Proj(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *arg, ir_mode *mode, long proj)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[1];
	in[0] = arg;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Proj, mode, 1, in);
	res->attr.proj = proj;
assert(get_Proj_pred(res));
	assert(get_nodes_block(get_Proj_pred(res)));
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Proj(ir_graph *irg, ir_node *block, ir_node *arg, ir_mode *mode, long proj)
{
	return new_rd_Proj(NULL, irg, block, arg, mode, proj);
}

ir_node *new_d_Proj(dbg_info *db, ir_node *arg, ir_mode *mode, long proj)
{
	ir_node *res;
	res = new_rd_Proj(db, current_ir_graph, current_ir_graph->current_block, arg, mode, proj);
	return res;
}

ir_node *new_Proj(ir_node *arg, ir_mode *mode, long proj)
{
	return new_d_Proj(NULL, arg, mode, proj);
}

ir_node *new_rd_Cast(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *op, ir_type * totype)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[1];
	in[0] = op;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Cast, get_irn_mode(op), 1, in);
	res->attr.cast.totype = totype;
assert(is_atomic_type(totype));
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Cast(ir_graph *irg, ir_node *block, ir_node *op, ir_type * totype)
{
	return new_rd_Cast(NULL, irg, block, op, totype);
}

ir_node *new_d_Cast(dbg_info *db, ir_node *op, ir_type * totype)
{
	ir_node *res;
	res = new_rd_Cast(db, current_ir_graph, current_ir_graph->current_block, op, totype);
	return res;
}

ir_node *new_Cast(ir_node *op, ir_type * totype)
{
	return new_d_Cast(NULL, op, totype);
}

ir_node *new_rd_IJmp(dbg_info *db, ir_graph *irg, ir_node *block, ir_node *target)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	ir_node *in[1];
	in[0] = target;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_IJmp, mode_X, 1, in);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_IJmp(ir_graph *irg, ir_node *block, ir_node *target)
{
	return new_rd_IJmp(NULL, irg, block, target);
}

ir_node *new_d_IJmp(dbg_info *db, ir_node *target)
{
	ir_node *res;
	res = new_rd_IJmp(db, current_ir_graph, current_ir_graph->current_block, target);
	return res;
}

ir_node *new_IJmp(ir_node *target)
{
	return new_d_IJmp(NULL, target);
}

ir_node *new_rd_Jmp(dbg_info *db, ir_graph *irg, ir_node *block)
{
	ir_node *res;
	ir_graph *rem = current_ir_graph;
	current_ir_graph = irg;
	res = new_ir_node(db, irg, block, op_Jmp, mode_X, 0, NULL);
	res = optimize_node(res);
	IRN_VRFY_IRG(res, irg);
	current_ir_graph = rem;
	return res;
}

ir_node *new_r_Jmp(ir_graph *irg, ir_node *block)
{
	return new_rd_Jmp(NULL, irg, block);
}

ir_node *new_d_Jmp(dbg_info *db)
{
	ir_node *res;
	res = new_rd_Jmp(db, current_ir_graph, current_ir_graph->current_block);
	return res;
}

ir_node *new_Jmp(void)
{
	return new_d_Jmp(NULL);
}

